# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['ResourceArgs', 'Resource']

@pulumi.input_type
class ResourceArgs:
    def __init__(__self__, *,
                 private: pulumi.Input[builtins.str],
                 private_data: pulumi.Input['DataArgs'],
                 public: pulumi.Input[builtins.str],
                 public_data: pulumi.Input['DataArgs']):
        """
        The set of arguments for constructing a Resource resource.
        """
        pulumi.set(__self__, "private", private)
        pulumi.set(__self__, "private_data", private_data)
        pulumi.set(__self__, "public", public)
        pulumi.set(__self__, "public_data", public_data)

    @property
    @pulumi.getter
    def private(self) -> pulumi.Input[builtins.str]:
        return pulumi.get(self, "private")

    @private.setter
    def private(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "private", value)

    @property
    @pulumi.getter(name="privateData")
    def private_data(self) -> pulumi.Input['DataArgs']:
        return pulumi.get(self, "private_data")

    @private_data.setter
    def private_data(self, value: pulumi.Input['DataArgs']):
        pulumi.set(self, "private_data", value)

    @property
    @pulumi.getter
    def public(self) -> pulumi.Input[builtins.str]:
        return pulumi.get(self, "public")

    @public.setter
    def public(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "public", value)

    @property
    @pulumi.getter(name="publicData")
    def public_data(self) -> pulumi.Input['DataArgs']:
        return pulumi.get(self, "public_data")

    @public_data.setter
    def public_data(self, value: pulumi.Input['DataArgs']):
        pulumi.set(self, "public_data", value)


class Resource(pulumi.CustomResource):

    pulumi_type = "secret:index:Resource"

    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 private: Optional[pulumi.Input[builtins.str]] = None,
                 private_data: Optional[pulumi.Input[Union['DataArgs', 'DataArgsDict']]] = None,
                 public: Optional[pulumi.Input[builtins.str]] = None,
                 public_data: Optional[pulumi.Input[Union['DataArgs', 'DataArgsDict']]] = None,
                 __props__=None):
        """
        Create a Resource resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ResourceArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a Resource resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param ResourceArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ResourceArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 private: Optional[pulumi.Input[builtins.str]] = None,
                 private_data: Optional[pulumi.Input[Union['DataArgs', 'DataArgsDict']]] = None,
                 public: Optional[pulumi.Input[builtins.str]] = None,
                 public_data: Optional[pulumi.Input[Union['DataArgs', 'DataArgsDict']]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ResourceArgs.__new__(ResourceArgs)

            if private is None and not opts.urn:
                raise TypeError("Missing required property 'private'")
            __props__.__dict__["private"] = None if private is None else pulumi.Output.secret(private)
            if private_data is None and not opts.urn:
                raise TypeError("Missing required property 'private_data'")
            __props__.__dict__["private_data"] = None if private_data is None else pulumi.Output.secret(private_data)
            if public is None and not opts.urn:
                raise TypeError("Missing required property 'public'")
            __props__.__dict__["public"] = public
            if public_data is None and not opts.urn:
                raise TypeError("Missing required property 'public_data'")
            __props__.__dict__["public_data"] = public_data
        secret_opts = pulumi.ResourceOptions(additional_secret_outputs=["private", "privateData"])
        opts = pulumi.ResourceOptions.merge(opts, secret_opts)
        super(Resource, __self__).__init__(
            'secret:index:Resource',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'Resource':
        """
        Get an existing Resource resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = ResourceArgs.__new__(ResourceArgs)

        __props__.__dict__["private"] = None
        __props__.__dict__["private_data"] = None
        __props__.__dict__["public"] = None
        __props__.__dict__["public_data"] = None
        return Resource(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def private(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "private")

    @property
    @pulumi.getter(name="privateData")
    def private_data(self) -> pulumi.Output['outputs.Data']:
        return pulumi.get(self, "private_data")

    @property
    @pulumi.getter
    def public(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "public")

    @property
    @pulumi.getter(name="publicData")
    def public_data(self) -> pulumi.Output['outputs.Data']:
        return pulumi.get(self, "public_data")

